Package net.commoble.exmachina.api

# Record Class SignalGraphKey

java.lang.Object
java.lang.Record
net.commoble.exmachina.api.SignalGraphKey

Record Components:
  `levelKey` - ResourceKey of the level where this node is
  `pos` - BlockPos where this node is
  `shape` - NodeShape of this node
  `channel` - Channel this node is on

public record SignalGraphKey(net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey, net.minecraft.core.BlockPos pos, NodeShape shape, Channel channel) extends Record
Uniquely identifiable key in the signal graph

## Constructor Summary

Constructors
Constructor
Description
`SignalGraphKey(net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey, net.minecraft.core.BlockPos pos, NodeShape shape, Channel channel)`
Creates an instance of a `SignalGraphKey` record class.

## Method Summary

Modifier and Type
Method
Description
`Channel`
`channel()`
Returns the value of the `channel` record component.
`final boolean`
`equals(Object o)`
Indicates whether some other object is "equal to" this one.
`final int`
`hashCode()`
Returns a hash code value for this object.
`boolean`
`isValidFor(SignalGraphKey preferredNode)`
Returns true if this node exists at the position of a preferred node and the nodeshapes and channels are compatible.
`net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level>`
`levelKey()`
Returns the value of the `levelKey` record component.
`net.minecraft.core.BlockPos`
`pos()`
Returns the value of the `pos` record component.
`NodeShape`
`shape()`
Returns the value of the `shape` record component.
`final String`
`toString()`
Returns a string representation of this record class.

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### SignalGraphKey

public SignalGraphKey(net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey, net.minecraft.core.BlockPos pos, NodeShape shape, Channel channel)
Creates an instance of a `SignalGraphKey` record class.

Parameters:
  `levelKey` - the value for the `levelKey` record component
  `pos` - the value for the `pos` record component
  `shape` - the value for the `shape` record component
  `channel` - the value for the `channel` record component

## Method Details

### isValidFor

public boolean isValidFor(SignalGraphKey preferredNode)
Returns true if this node exists at the position of a preferred node and the nodeshapes and channels are compatible.

Parameters:
  `preferredNode` - Node which the thing which is trying to connect to this node is trying to connect to
Returns:
  true if this node exists at the position of a preferred node and the nodeshapes and channels are compatible

### toString

public final String toString()
Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.

Specified by:
  `toString` in class `Record`
Returns:
  a string representation of this object

### hashCode

public final int hashCode()
Returns a hash code value for this object. The value is derived from the hash code of each of the record components.

Specified by:
  `hashCode` in class `Record`
Returns:
  a hash code value for this object

### equals

public final boolean equals(Object o)
Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.

Specified by:
  `equals` in class `Record`
Parameters:
  `o` - the object with which to compare
Returns:
  `true` if this object is the same as the `o` argument; `false` otherwise.

### levelKey

public net.minecraft.resources.ResourceKey<net.minecraft.world.level.Level> levelKey()
Returns the value of the `levelKey` record component.

Returns:
  the value of the `levelKey` record component

### pos

public net.minecraft.core.BlockPos pos()
Returns the value of the `pos` record component.

Returns:
  the value of the `pos` record component

### shape

public NodeShape shape()
Returns the value of the `shape` record component.

Returns:
  the value of the `shape` record component

### channel

public Channel channel()
Returns the value of the `channel` record component.

Returns:
  the value of the `channel` record component